// Convert bignum to string

#include "stdafx.h"
#include "defs.h"

static int divby1billion(unsigned int *);

static char *str=0;
static int len=0;

// sprintf 0<=r<999999999
static void mysprintf9(char * ptr,int r){
  for (int i=8;i>=0;--i){
    *(ptr+i)='0'+r%10;
    r/=10;
  }
}

void print_int(char * & ptr,int r){
  if (r<0){
    *ptr='-';
    ++ptr;
    r=-r;
  }
  int i;
  if (r==0){
    *ptr='0';
    *(ptr+1)=0;
  }
  *(ptr+10)=0;
  for (i=9;r;--i){
    *(ptr+i)='0'+r%10;
    r/=10;
  }
  ++i;
  if (i>0){ // shift left i char
    char * buf;
    for (buf=ptr+i;buf<=ptr+9;++buf){
      *(buf-i)=*buf;
    }
    *(buf-i)=0;
    ptr=buf-i;
  }
  else
    ptr += 10;
}

void print_double(char * & buf,double d){
  if (d==0){
    strcpy(buf,"0.0");
    buf+=4;
    return;
  }
  if (d<0){
    *buf='-';
    ++buf;
    d=-d;
  }
  int i=d;
  if (i==d && d<1e9){
    print_int(buf,i);
    return;
  }
  for (i=0;i<280 && d>=1.0;i+=14){
    d=d/1e14;
  }
  for (;i>-280 && d<1.0;i-=14){
    d=d*1e14;
  }
  for (;i<310 && d>=1.0;++i){
    d=d/10;
  }
  if (i==310){
    strcpy(buf,"inf");
    buf +=4;
    return;
  }
  for (;i>-310 && d<1.0;--i){
    d=d*10;
  }
  if (i==-310){
    strcpy(buf,"0.0");
    buf +=4;
    return;
  }
  // 1.0<=d<10, d*10^i
  d=d/10; ++i; // 0.1<=d<1, d*10^i
  *buf='.';
  char * ptr=buf;
  ++buf;
  int r=int(d*1e9+.5);
  if (r>=1e9){
    r=r/10;
    ++i;
  }
  print_int(buf,r);
  if (i>0 && i<7){
    // move . i positions to the right
    for (int j=0;j<i;++j){
      *ptr=*(ptr+1);
      ++ptr;
    }
    *ptr='.';
    i=0;
  }
  for (;;--buf){
    char ch=*(buf-1);
    if (ch!='0'){
      *buf=0;
      break;
    }
  }
  if (i!=0){
    *buf='e';
    ++buf;
    print_int(buf,i);
  }
}


char *
mstr(unsigned int *a)
{
	int k, n, r, sign;
	char c;

	if (str == NULL) {
		str = (char *) malloc(1000);
		len = 1000;
	}

	// estimate string size

	n = 10 * MLENGTH(a) + 2;

	if (n > len) {
		free(str);
		str = (char *) malloc(n);
		len = n;
	}

	sign = MSIGN(a);

	a = mcopy(a);

	k = len - 1;

	str[k] = 0;

	for (;;) {
		k -= 9;
		r = divby1billion(a);
		c = str[k + 9];
		mysprintf9(str+k,r);// sprintf(str + k, "%09d", r);
		str[k + 9] = c;
		if (MZERO(a))
			break;
	}

	// remove leading zeroes

	while (str[k] == '0')
		k++;

	if (str[k] == 0)
		k--;

	// sign

	if (sign == -1) {
		k--;
		str[k] = '-';
	}

	mfree(a);

	return str + k;
}

// Returns remainder as function value, quotient returned in a.

static int
divby1billion(unsigned int *a)
{
	int i;
	unsigned long long kk;

	kk = 0;

	for (i = MLENGTH(a) - 1; i >= 0; i--) {

		if (little_endian()) {
			((unsigned int *) &kk)[1] = ((unsigned int *) &kk)[0];
			((unsigned int *) &kk)[0] = a[i];
		} else {
			((unsigned int *) &kk)[0] = ((unsigned int *) &kk)[1];
			((unsigned int *) &kk)[1] = a[i];
		}

		a[i] = (int) (kk / 1000000000);

		kk -= (unsigned long long) 1000000000 * a[i];
	}

	// length of quotient

	for (i = MLENGTH(a) - 1; i > 0; i--)
		if (a[i])
			break;

	MLENGTH(a) = i + 1;

	if (little_endian())
		return ((unsigned int *) &kk)[0];
	else
		return ((unsigned int *) &kk)[1];
}
